
// GPL
// Съемка сферической панорамы камерами Sony NEX-5 и CasioQV-4000 с управлением по BT от Android для Arduino Mega
// www.rwpbb.ru, 2012 

#include <MeetAndroid.h>
// declare MeetAndroid so that you can call functions with it
MeetAndroid meetAndroid;
int pulscount=1;  // Счетчик числа импульсов в пакете ИК
int puls = 4;    // Число пакетов ИК

int enable1 = 7;
int enable2 = 10;
int enable = enable1;
int inp1 = 8;
int inp2 = 6;
int inp3 = 5;
int inp4 = 4;
int dt1 = 5;
int faz1 = 0;//Фаза первого мотора
int faz2 = 0;
int buttonPin = 9;       // Ножка перемычки. Если 5В, то съемка с насадкой в два ряда 
int buttonState = 0;     // Состояние перемычки
int wzat = 3000;         // Время нажатия кнопки затвора - 3 с
int wp = 4000;           // Пауза перед спуском затвора - 4 с
long mstepx = 0;         // Поворот по горизонтали исчисляемый в шагах двигателя
long mstepxx = 0;        // Число шагов двигателя при повороте на единичный угол по горизонтали (360 - 1400)
long mstepxd = 0;        // Число шагов двигателя
int napr = 0;            // Направление вращения. Вперед 1, Назад -1 
int nmstepx = 4;         // 5 снимков в ряду по горизонтали для съемки с насадкой
long mstepy = 2500;
long mstepyy = 2500;     // Число шагов двигателя при повороте на 90
long mstepyd = 0;

int nmstepy = 1;
int flagO = 1;            //Флаг наличия насадки 1, без 0
int ugolV = 90;
int ugolG = 0;
void setup() 
{ 
  pinMode(enable1, OUTPUT);
  pinMode(enable2, OUTPUT);
  pinMode(inp1, OUTPUT);
  pinMode(inp2, OUTPUT);
  pinMode(inp3, OUTPUT);
  pinMode(inp4, OUTPUT);
  digitalWrite(enable1, LOW);
  digitalWrite(enable2, LOW);
  digitalWrite(inp1, LOW);
  digitalWrite(inp2, LOW);
  digitalWrite(inp3, LOW);
  digitalWrite(inp4, LOW);
  Faza();
  enable = enable2;
  Faza;
  
  Serial1.begin(57600);//BT
  Serial2.begin(9600); //Casio
  
  // register callback functions, which will be called when an associated event occurs.
  meetAndroid.registerFunction(fo, 'o');//Затвор
  meetAndroid.registerFunction(fp, 'p');//Низ  
  meetAndroid.registerFunction(fq, 'q');//Право 
  meetAndroid.registerFunction(fr, 'r');//Лево
  meetAndroid.registerFunction(fs, 's');//Верх  
  meetAndroid.registerFunction(ft, 't');//Пуск
  meetAndroid.registerFunction(fw, 'w');//W
  meetAndroid.registerFunction(fz, 'z');//T
  meetAndroid.registerFunction(fk, 'k');//Передача параметра - Задержка
  meetAndroid.registerFunction(fl, 'l');//Передача параметра - Объектив
  meetAndroid.registerFunction(fm, 'm');//Передача параметра - Панорама
  meetAndroid.registerFunction(fn, 'n');//Передача параметра - Вертикальных шагов
  meetAndroid.registerFunction(fe, 'e');//Передача параметра - Горизонтальных шагов
  meetAndroid.registerFunction(ff, 'f');//Передача параметра - Горизонтальный угол
  meetAndroid.registerFunction(fg, 'g');//Передача параметра - Вертикальный угол
  
 TCCR1A = _BV(COM1A1) | _BV(COM1B1) ; // phase and frequency correct mode. NON-inverted mode
 TCCR1B = _BV(WGM13) | _BV(CS10);     // Делитель N = 1 - (_BV(CS10)); 8 - (_BV(CS11))
 OCR1B = 0;              // Скважность 102 - рабочий сигнал, 0 - сигнал отсутствует
 ICR1 = 210;             // Частота 16мГц/2*N*ICR1 = 16000кГц/(2*1*210)=38095Гц
 pinMode(12, OUTPUT);    // К 12 (на mega) ножке подключен ИК светодиод АЛ107 через сопротивление 1 кОм

// pinMode(buttonPin, INPUT); // Включаем ножку на прием сигналов
// digitalWrite(buttonPin, LOW); //включаем подтягивающие резисторы на землю
// buttonState = digitalRead(buttonPin); // Чтение состояния перемычки
// if (buttonState == LOW){flagO = 0;}

                         
        
}
void loop()  {
   meetAndroid.receive(); // you need to keep this in your loop() to receive events

    }
void Zatvor() 
{
    digitalWrite(13, HIGH);//Индикация паузы светодиодом на плате
    delay(wp);// Пауза перед спуском затвора 
    digitalWrite(13, LOW);
IR_Sony();
byte inByte = 66;
Serial2.write(inByte);
delay(15);
inByte = 98;
Serial2.write(inByte);
    digitalWrite(13, HIGH);
    delay(wzat); // Время нажатия кнопки затвора
    digitalWrite(13, LOW);    
}
void IR_Sony()  { //Подпрограмма подачи ИК сигналя для спуска зотвора камеры NEX5
 
  pulscount=1;  
   while (pulscount<puls)          // цикл пакета импульсов  
    
    {OCR1B = 102;   // включаем светодиод
    delayMicroseconds(2432);       // светодиод горит микросекунд
    OCR1B = 0;     // выключаем светодиод
    delayMicroseconds(576);       // светодиод выключен  микросекунд
    OCR1B = 102;   // включаем светодиод
    delayMicroseconds(1216);       
    OCR1B = 0;     
    delayMicroseconds(576); 
    OCR1B = 102;   // включаем светодиод
    delayMicroseconds(640);       
    OCR1B = 0;     
    delayMicroseconds(576);
    OCR1B = 102;   // включаем светодиод
    delayMicroseconds(1216);       
    OCR1B = 0;     
    delayMicroseconds(576);
    OCR1B = 102;   // включаем светодиод
    delayMicroseconds(1216);       
    OCR1B = 0;     
    delayMicroseconds(576);
    OCR1B = 102;   // включаем светодиод
    delayMicroseconds(640);       
    OCR1B = 0;     
    delayMicroseconds(576);
    OCR1B = 102;   // включаем светодиод
    delayMicroseconds(1216);       
    OCR1B = 0;     
    delayMicroseconds(576);
    OCR1B = 102;   // включаем светодиод
    delayMicroseconds(640);       
    OCR1B = 0;     
    delayMicroseconds(576);
    OCR1B = 102;   // включаем светодиод
    delayMicroseconds(640);       
    OCR1B = 0;     
    delayMicroseconds(576);
    OCR1B = 102;   // включаем светодиод
    delayMicroseconds(1216);       
    OCR1B = 0;     
    delayMicroseconds(576);
    OCR1B = 102;   // включаем светодиод
    delayMicroseconds(640);       
    OCR1B = 0;     
    delayMicroseconds(576);
     OCR1B = 102;   // включаем светодиод
    delayMicroseconds(1216);       
    OCR1B = 0;     
    delayMicroseconds(576);
    OCR1B = 102;   // включаем светодиод
    delayMicroseconds(1216);       
    OCR1B = 0;     
    delayMicroseconds(576);
    OCR1B = 102;   // включаем светодиод
    delayMicroseconds(1216);       
    OCR1B = 0;     
    delayMicroseconds(576);
    OCR1B = 102;   // включаем светодиод
    delayMicroseconds(640);       
    OCR1B = 0;     
    delayMicroseconds(576);
    OCR1B = 102;   // включаем светодиод
    delayMicroseconds(640);       
    OCR1B = 0;     
    delayMicroseconds(576);
    OCR1B = 102;   // включаем светодиод
    delayMicroseconds(640);       
    OCR1B = 0;     
    delayMicroseconds(576);
    OCR1B = 102;   // включаем светодиод
    delayMicroseconds(1216);       
    OCR1B = 0;     
    delayMicroseconds(576);
    OCR1B = 102;   // включаем светодиод
    delayMicroseconds(1216);       
    OCR1B = 0;     
    delayMicroseconds(576);
    OCR1B = 102;   // включаем светодиод
    delayMicroseconds(1216);       
    OCR1B = 0;     
    delayMicroseconds(576);
    OCR1B = 102;   // включаем светодиод
    delayMicroseconds(1216);       
    OCR1B = 0;     
    delayMicroseconds(11136);
    pulscount++;
    }
  
}

void Pano_Motor()  {
  if (flagO == 0) 
      {
        mstepxx = 140;
        nmstepx = 9;
        mstepyy = 1500;
        nmstepy = 2;
      }
      else
      {
        mstepxx = 280;
        nmstepx = 4;
        mstepyy = 1672;
        nmstepy = 1;
      }
     // Поворачиваем вниз      
     mstepyd =  mstepyy*nmstepy/2;
     napr = -1;
     enable = enable2;
     for (int i=0; i <= mstepyd; i++)
              { 
  mstepy = mstepy + napr;
  Faza();
              }
     SendUgolV();//Передаем данные об  угле телефону     

  for (int k=0; k <= nmstepx; k++)
      {
      
       Zatvor();   // Нажимаем спусковую кнопку
       mstepxd = mstepxx;
       napr = 1;
      enable = enable1;
     for (int i=0; i <= mstepxd; i++)
              { 
  mstepx = mstepx + napr;
  Faza();
              }
       SendUgolG();//Передаем данные об горизонтальном угле телефону
      } 
 
     // Поворачиваем на пол угла по горизонтали
     mstepxd = mstepxx/2;
     napr = 1;
     enable = enable1;
     for (int i=0; i <= mstepxd; i++)
              { 
  mstepx = mstepx + napr;
  Faza();
              }
     SendUgolG();//Передаем данные об горизонтальном угле телефону
     
     // Поворачиваем камеру вверх
     mstepyd =  mstepyy;
     napr = 1;
     enable = enable2;
     for (int i=0; i <= mstepyd; i++)
              { 
  mstepy = mstepy + napr;
  Faza();
              }
     SendUgolV();//Передаем данные об  угле телефону
     
  for (int k=0; k <= (nmstepx-1); k++)
            {     
       Zatvor();   // Нажимаем спусковую кнопку
                
       mstepxd = mstepxx;
       napr = 1;
enable = enable1;
     for (int i=0; i <= mstepxd; i++)
              { 
  mstepx = mstepx + napr;
  Faza();
              }
       SendUgolG();//Передаем данные об горизонтальном угле телефону
            }
     
     Zatvor();   // Нажимаем спусковую кнопку
      // Поворачиваем на пол угла по горизонтали
     mstepxd = mstepxx/2;
     napr = 1;
     enable = enable1;
     for (int i=0; i <= mstepxd; i++)
              { 
  mstepx = mstepx + napr;
  Faza();
              }
     SendUgolG();//Передаем данные об горизонтальном угле телефону
 
  if (flagO == 0) 
      {
       // Поворачиваем камеру вверх
     mstepyd =  mstepyy;
     napr = 1;
     enable = enable2;
     for (int i=0; i <= mstepyd; i++)
              { 
  mstepy = mstepy + napr;
  Faza();
              }
     SendUgolV();//Передаем данные об  угле телефону
       
    for (int k=0; k <= (nmstepx); k++)
              {     
         Zatvor();   // Нажимаем спусковую кнопку
                  
         mstepxd = mstepxx;
         napr = 1;
     enable = enable1;
     for (int i=0; i <= mstepxd; i++)
              { 
  mstepx = mstepx + napr;
  Faza();
              }
         SendUgolG();//Передаем данные об горизонтальном угле телефону
              }   
      
      }

     // Поворачиваем вниз в исходное состояние    
     mstepyd =  mstepyy*nmstepy/2;
     napr = -1;
     enable = enable2;
     for (int i=0; i <= mstepyd; i++)
              { 
  mstepy = mstepy + napr;
  Faza();
              }
     SendUgolV();//Передаем данные об  угле телефону
     
}

void Pan_Motor()  {
  int nm = nmstepy;
  if (nm == 0)
  {
  for (int k=0; k < nmstepx; k++)
      {
      
       Zatvor();   // Нажимаем спусковую кнопку
       mstepxd = mstepxx;
       napr = 1;
      enable = enable1;
     for (int i=0; i <= mstepxd; i++)
              { 
  mstepx = mstepx + napr;
  Faza();
              }
       SendUgolG();//Передаем данные об горизонтальном угле телефону
      } 
   Zatvor();   // Нажимаем спусковую кнопку  
  }
  else
  {
     // Поворачиваем вниз      
     mstepyd =  mstepyy*nmstepy/2;
     napr = -1;
     enable = enable2;
     for (int i=0; i <= mstepyd; i++)
              { 
  mstepy = mstepy + napr;
  Faza();
              }
     SendUgolV();//Передаем данные об  угле телефону     

  Mpan();
  nm = nm - 1;
  while (nm > 0){
   // Поворачиваем камеру вверх
     mstepyd =  mstepyy;
     napr = 1;
     enable = enable2;
     for (int i=0; i <= mstepyd; i++)
              { 
  mstepy = mstepy + napr;
  Faza();
              }
     SendUgolV();//Передаем данные об  угле телефону
    Mpan();
    nm = nm - 2;
  }
     
     // Поворачиваем вниз в исходное состояние    
     mstepyd =  mstepyy*nmstepy/2;
     napr = -1;
     enable = enable2;
     for (int i=0; i <= mstepyd; i++)
              { 
  mstepy = mstepy + napr;
  Faza();
              }
     SendUgolV();//Передаем данные об  угле телефону
  }    
}

void Mpan(){
for (int k=0; k < nmstepx; k++)
      {
      
       Zatvor();   // Нажимаем спусковую кнопку
       mstepxd = mstepxx;
       napr = 1;
      enable = enable1;
     for (int i=0; i <= mstepxd; i++)
              { 
  mstepx = mstepx + napr;
  Faza();
              }
       SendUgolG();//Передаем данные об горизонтальном угле телефону
      } 
   Zatvor();   // Нажимаем спусковую кнопку  
     // Поворачиваем камеру вверх
     mstepyd =  mstepyy;
     napr = 1;
     enable = enable2;
     for (int i=0; i <= mstepyd; i++)
              { 
  mstepy = mstepy + napr;
  Faza();
              }
     SendUgolV();//Передаем данные об  угле телефону
     
  for (int k=0; k < nmstepx; k++)
            {     
       Zatvor();   // Нажимаем спусковую кнопку
                
       mstepxd = mstepxx;
       napr = -1;
enable = enable1;
     for (int i=0; i <= mstepxd; i++)
              { 
  mstepx = mstepx + napr;
  Faza();
              }
       SendUgolG();//Передаем данные об горизонтальном угле телефону
            }
     
     Zatvor();   // Нажимаем спусковую кнопку
}

void fk(byte flag, byte numOfValues)//Задержка
{

     wp = 1000*meetAndroid.getInt();
  
}

void fl(byte flag, byte numOfValues)//Объектив. Флаг наличия насадки 1, без 0.
{
  flagO = meetAndroid.getInt();
  if(flagO == 0){   
  digitalWrite(13, HIGH);//Индикация светодиодом на плате
  delay(1000); 
  digitalWrite(13, LOW);
  delay(1000);              
  digitalWrite(13, HIGH);//Индикация светодиодом на плате
  delay(1000); 
  digitalWrite(13, LOW);}
  
  if(flagO == 1){
  for (int i=0; i <= 5; i++)
              { 
  digitalWrite(13, HIGH);//Индикация светодиодом на плате
  delay(300); 
  digitalWrite(13, LOW);
  delay(300);
              }
                }
}

void fm(byte flag, byte numOfValues)
{

    wzat = 1000*meetAndroid.getInt();
      Pan_Motor();
  
}

void fn(byte flag, byte numOfValues)
{

    nmstepy = meetAndroid.getInt();
  
}

void fe(byte flag, byte numOfValues)
{

    nmstepx = meetAndroid.getInt();
  
}

void ff(byte flag, byte numOfValues)
{

    int ff = meetAndroid.getInt();
     mstepxx =  35*ff/9;
  
}

void fg(byte flag, byte numOfValues)
{

    int fg = meetAndroid.getInt();
     mstepyy =  250*fg/9+1;
  
}

void fo(byte flag, byte numOfValues)//Затвор
{

     wzat = 1000*meetAndroid.getInt();
       Zatvor();
}

void fw(byte flag, byte numOfValues)//Зум W
{

     int fw = meetAndroid.getInt();
       digitalWrite(13, HIGH);
       byte inByte = 67;
       Serial2.write(inByte);
        
        delay(fw);
        
       inByte = 99;
       Serial2.write(inByte);
       digitalWrite(13, LOW);
}

void fz(byte flag, byte numOfValues)//Зум T
{

     int fw = meetAndroid.getInt();
     digitalWrite(13, HIGH);
       byte inByte = 68;
       Serial2.write(inByte);
        delay(fw);
       inByte = 100;
       Serial2.write(inByte);
       digitalWrite(13, LOW);
}

void fp(byte flag, byte numOfValues)//Низ
{
 int fp = meetAndroid.getInt();
     mstepyd =  250*fp/9+1;
     napr = -1;
     enable = enable2;
     for (int i=0; i <= mstepyd; i++)
              { 
  mstepy = mstepy + napr;
  Faza();
              }

     SendUgolV();//Передаем данные об  угле телефону
}

void fq(byte flag, byte numOfValues)//Поворот по часовой стрелке в 
{
  int fq = meetAndroid.getInt();
     mstepxd =  35*fq/9;
     napr = 1;
      enable = enable1;
     for (int i=0; i <= mstepxd; i++)
              { 
  mstepx = mstepx + napr;
  Faza();
              }

     SendUgolG();//Передаем данные об горизонтальном угле телефону
}
void fr(byte flag, byte numOfValues)
{
  int fr = meetAndroid.getInt();
     mstepxd =  35*fr/9;
     napr = -1;
      enable = enable1;
     for (int i=0; i <= mstepxd; i++)
              { 
  mstepx = mstepx + napr;
  Faza();
              }

     SendUgolG();//Передаем данные об горизонтальном угле телефону
}

void fs(byte flag, byte numOfValues)//Вверх
{
  int fs = meetAndroid.getInt();
     mstepyd =  250*fs/9+1;
     napr = 1;
       enable = enable2;
     for (int i=0; i <= mstepyd; i++)
              { 
  mstepy = mstepy + napr;
  Faza();
              }

     SendUgolV();//Передаем данные об  угле телефону
}

void ft(byte flag, byte numOfValues)//Пуск
{
      wzat = 1000*meetAndroid.getInt();
      Pano_Motor();
}

void SendUgolG()//Передаем данные об горизонтальном угле телефону
{
     if (mstepx > 1400){
       
      mstepx = mstepx - 1400;
   }
     else if (mstepx < 0){
       
       mstepx = mstepx + 1400;  
   } 
    float ugol = 9*mstepx/35;
    ugolG = (int)ugol;
 
     meetAndroid.send("A");
     delay(200);
     meetAndroid.send(ugolG);
}

void SendUgolV()//Передаем данные об вертикальном угле телефону
{
     float ugol = (9*mstepy)/250;
     ugolV = (int)ugol;
     meetAndroid.send("B");
     delay(200);
     meetAndroid.send(ugolV);
}
void Faza() {
byte fazaA[] = {HIGH, HIGH, LOW, LOW};
byte fazaB[] = {LOW, LOW, HIGH, HIGH};
byte fazaC[] = {LOW, HIGH, HIGH, LOW};
byte fazaD[] = {HIGH, LOW, LOW, HIGH};
int faz;
if (enable == enable1)
{
  faz1 = faz1 + napr;
  if (faz1 > 3)
  {faz1 = 0;}
  else if (faz1 < 0)
  {faz1 = 3;}
  faz = faz1; 
}
else
{
  faz2 = faz2 + napr;
  if (faz2 > 3)
  {faz2 = 0;}
  else if (faz2 < 0)
  {faz2 = 3;}
  faz = faz2; 
}
digitalWrite(enable, HIGH);
  digitalWrite(inp1, fazaA[faz]);
  digitalWrite(inp2, fazaB[faz]);
  digitalWrite(inp3, fazaC[faz]);
  digitalWrite(inp4, fazaD[faz]);      
  delay(dt1);
digitalWrite(enable, LOW);
            }

